SystemOrganization addCategory: #BloodType!

TestCase subclass: #BloodTypeTest
	instanceVariableNames: 'bloodType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BloodType'!

!BloodTypeTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 19:07'!
setUp

	super setUp.
	bloodType := BloodType new.! !

!BloodTypeTest methodsFor: 'gene combination' stamp: 'hjo 9/17/2011 19:09'!
testAAndA

	bloodType gene1: #a.
	bloodType gene2: #a.
	self assert: bloodType bloodType equals: #A.
! !

!BloodTypeTest methodsFor: 'gene combination' stamp: 'hjo 9/17/2011 19:09'!
testAAndB

	bloodType gene1: #a.
	bloodType gene2: #b.
	self assert: bloodType bloodType equals: #AB.
! !

!BloodTypeTest methodsFor: 'gene combination' stamp: 'hjo 9/17/2011 19:09'!
testAAndO

	bloodType gene1: #a.
	bloodType gene2: #o.
	self assert: bloodType bloodType equals: #A.
! !

!BloodTypeTest methodsFor: 'gene combination' stamp: 'hjo 9/17/2011 19:10'!
testBAndA

	bloodType gene1: #b.
	bloodType gene2: #a.
	self assert: bloodType bloodType equals: #AB.
! !

!BloodTypeTest methodsFor: 'gene combination' stamp: 'hjo 9/17/2011 19:10'!
testBAndB

	bloodType gene1: #b.
	bloodType gene2: #b.
	self assert: bloodType bloodType equals: #B.
! !

!BloodTypeTest methodsFor: 'gene combination' stamp: 'hjo 9/17/2011 19:10'!
testBAndO

	bloodType gene1: #b.
	bloodType gene2: #o.
	self assert: bloodType bloodType equals: #B.
! !

!BloodTypeTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 19:17'!
testCanParentOfBloodTypeOfHaveChildOfBloodType

	self assert: (BloodType canParentOfBloodTypeOf: #A and: #B haveChildOfBloodType: #O).
	self assert: (BloodType canParentOfBloodTypeOf: #A and: #B haveChildOfBloodType: #AB).
	self deny: (BloodType canParentOfBloodTypeOf: #AB and: #AB haveChildOfBloodType: #O).! !

!BloodTypeTest methodsFor: 'gene combination' stamp: 'hjo 9/17/2011 19:08'!
testOAndA

	bloodType gene1: #o.
	bloodType gene2: #a.
	self assert: bloodType bloodType equals: #A.
! !

!BloodTypeTest methodsFor: 'gene combination' stamp: 'hjo 9/17/2011 19:08'!
testOAndB

	bloodType gene1: #o.
	bloodType gene2: #b.
	self assert: bloodType bloodType equals: #B.
! !

!BloodTypeTest methodsFor: 'gene combination' stamp: 'hjo 9/17/2011 19:07'!
testOAndO

	bloodType gene1: #o.
	bloodType gene2: #o.
	self assert: bloodType bloodType equals: #O.
! !

!BloodTypeTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 19:11'!
testPossibleCases

	self assert: BloodType possibleCases size equals: 9! !

!BloodTypeTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 19:14'!
testPossibleParentCombinationToYieldAChildWithBloodType

	self assert: (BloodType possibleParentCombinationToYieldAChildWithBloodType: #AB) size equals: 18! !

Object subclass: #BloodType
	instanceVariableNames: 'gene1 gene2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BloodType'!

!BloodType classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 19:17'!
canParentOfBloodTypeOf: aByteSymbol and: aByteSymbol2 haveChildOfBloodType: aByteSymbol3 

	^((self possibleParentCombinationToYieldAChildWithBloodType: aByteSymbol3)
		select: [:parents| 
			parents first bloodType = aByteSymbol and: [parents second bloodType = aByteSymbol2].
 		]) notEmpty.! !

!BloodType classSide methodsFor: 'instance creation' stamp: 'hjo 9/17/2011 18:18'!
gene1: aByteSymbol gene2: aByteSymbol2 

	^self new
		gene1: aByteSymbol;
		gene2: aByteSymbol2;
		yourself! !

!BloodType classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 18:29'!
possibleABType

	^self possibleCases select: [:each| each bloodType = #AB ]
	! !

!BloodType classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 18:28'!
possibleAType

	^self possibleCases select: [:each| each bloodType = #A ]
	! !

!BloodType classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 18:28'!
possibleBType

	^self possibleCases select: [:each| each bloodType = #B ]
	! !

!BloodType classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 19:04'!
possibleCases

	^#((o a b) (o a b)) multiDimensionalCollect2: [:g1 :g2| self gene1: g1 gene2:  g2 ]

	! !

!BloodType classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 18:29'!
possibleOType

	^self possibleCases select: [:each| each bloodType = #O ]
	! !

!BloodType classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 18:35'!
possibleParentCombinationToYieldAChildWithBloodType: aByteSymbol 

	^{self possibleCases. self possibleCases} multiDimensionalSelect2: [:parent1 :parent2 |
		(parent1 makeChildWith: parent2) bloodType = aByteSymbol].  ! !

!BloodType methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 18:12'!
bloodType

	| geneSet |
	geneSet := Bag with: gene1 with: gene2.
	((geneSet occurrencesOf: #o) = 2) ifTrue: [^#O].
	((geneSet includes: #a) and: [geneSet includes: #b]) ifTrue: [^#AB]. 
	(geneSet includes: #a) ifTrue: [^#A].
	(geneSet includes: #b) ifTrue: [^#B].
	^nil! !

!BloodType methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 18:36'!
gene1

	^ gene1! !

!BloodType methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 17:48'!
gene1: aByteSymbol 

	gene1 := aByteSymbol! !

!BloodType methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 18:36'!
gene2
	^ gene2! !

!BloodType methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 17:48'!
gene2: aByteSymbol 

	gene2 := aByteSymbol! !

!BloodType methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 18:50'!
genoType

	^gene1, gene2! !

!BloodType methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2011 18:36'!
makeChildWith: aBT 

	^self class gene1: self gene1 gene2: aBT gene2! !
